#!/usr/bin/perl -w

use strict;

my $layout_file = 'fix-layout.pl';
my $fixed_file  = 'fix-layout.pl-fixed';

my $data = '';
open(F, $layout_file) || die "Cannot open file: $layout_file ($!)";
while(<F>) {
	#<td><pre>00000000</pre></td>
	#if(/<pre>00000120<\/pre>/) {
	#	$replace = 1;
	#}
	#elsif(/<pre>00000150<\/pre>/) {
	#	$replace = 0;
	#}
	#elsif($replace && s/bytes: \?{4}/bytes: 0280-0343/g) {
	#	print "Replaced.\n";
	#}
	
	#Index 1.*?Assignment Info Present.*?bytes:) \?{4}
	if(/^if\(\$_.*?s!\((Index )1(.*?bytes:).*?!.*?(\d{4})-(\d{4})!s/) {
		my $s = '';
		my $regex1 = $1;
		my $regex2 = $2;
		my $bytes1 = $3;
		my $bytes2 = $4;
		foreach(1..9) {
			if($_ > 1) {
				$bytes1 += 712;
				$bytes2 += 712;
			}
		
			$s .= "\t";
			$s .= 'if(/^(.*?';
			$s .= $regex1;
			$s .= $_;
			$s .= $regex2;
			$s .= ' )\?{4}(.*?\n)$/) {';
			$s .= "\n\t\t";
			$s .= '$_ = $1. \'' .sprintf("%04d", $bytes1). '-' .sprintf("%04d", $bytes2). '\' .$2;';
			$s .= "\n\t\t";
			$s .= 'print "replaced (' .$1. ' - ' .sprintf("%04d", $bytes1). '-' .sprintf("%04d", $bytes2). ')\n";';
			$s .= "\n\t";
			$s .= '}';
			$s .= "\n";
		}
	
		print "replaced:\n$s\n";
	
		$_ = $s;
	}
	
	#if(/^(if.*?Index )2(.*? )(\d{4})-(\d{4})(.*?\n)$/) {
	#	my $start = $1;
	#	my $more  = $2;
	#	my $num1  = $3;
	#	my $num2  = $4;
	#	my $end   = $5;
	#	
	#	if($num1 =~ s/^0+//){ print "Stripped 1\n"; }
	#	if($num2 =~ s/^0+//){ print "Stripped 2\n"; }
	#	
	#	my $line = '';
	#	$num1 -= 712;
	#	$num2 -= 712;
	#		
	#	$line .= $start. '1' .$more. sprintf("%04d", $num1) .'-'. sprintf("%04d", $num2) .$end;
	#	
	#
	#	print "Was : $_";
	#	print "Line: $line\n";
	#
	#	$_ = $line.$_;
	#}
	
	$data .= $_;
}
close F;

open(F, ">", $fixed_file) || die "Cannot open file: $fixed_file ($!)";
print F $data;
close F;
